/* Copyright (C) 2006 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#ifndef _PTHREAD_EXT_H
#define _PTHREAD_EXT_H	1

#include <features.h>
#include <pthread.h>

/* This API is very unportable and is for DCE compatibility only,
 * other applications should not use it.
 */

/* Exit state. */
enum
{
  PTHREAD_STATUS_ACTIVE_NP = 0,
#define PTHREAD_STATUS_ACTIVE_NP	PTHREAD_STATUS_ACTIVE_NP
  PTHREAD_STATUS_EXIT_NP
#define PTHREAD_STATUS_EXIT_NP		PTHREAD_STATUS_EXIT_NP
};

__BEGIN_DECLS

#ifdef __USE_GNU

/* Clear exit and cancellation flags on current thread */
extern int pthread_clear_exit_np (void);

/* Returns PTHREAD_STATUS_EXIT_NP if current thread is exiting
 * and sets __status to exit status */
extern int pthread_test_exit_np (void **__status);

__END_DECLS

#endif /* __USE_GNU */

#endif	/* pthread_ext.h */
